--- /dev/null	Wed Sep 25 20:51:53 2019
+++ new/usr/src/test/util-tests/tests/demangle/demangle_test.h	Wed Sep 25 20:51:53 2019
@@ -0,0 +1,89 @@
+/*
+ * This file and its contents are supplied under the terms of the
+ * Common Development and Distribution License ("CDDL"), version 1.0.
+ * You may only use this file in accordance with the terms of version
+ * 1.0 of the CDDL.
+ *
+ * A full copy of the text of the CDDL should have accompanied this
+ * source.  A copy of the CDDL is also available via the Internet at
+ * http://www.illumos.org/license/CDDL.
+ */
+
+/*
+ * Copyright 2019 Joyent, Inc.
+ */
+
+#ifndef _DEMANGLE_TEST_H
+#define	_DEMANGLE_TEST_H
+
+#include <demangle-sys.h>
+#include <sys/linker_set.h>
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+typedef struct demtest_case {
+	const char *dtc_mangled;
+	const char *dtc_demangled;
+} demtest_case_t;
+
+typedef struct demtest_group {
+	sysdem_lang_t	dtg_lang;
+	const char	*dtg_name;
+	demtest_case_t	dtg_tests[];
+} demtest_group_t;
+
+#define	T(_m, _d) { .dtc_mangled = _m, .dtc_demangled = _d }
+#define	T_ERR(_m) { .dtc_mangled = _m }
+
+#define	GROUP(_name, _lang, ...)		\
+	static demtest_group_t _name = {	\
+		.dtg_name = #_name,		\
+		.dtg_lang = _lang,		\
+		.dtg_tests = {			\
+			__VA_ARGS__,		\
+			{ NULL, NULL }		\
+		}				\
+	};					\
+	DATA_SET(demangle_tests, _name)
+
+/*
+ * Some things (e.g. the C++ mangled names with floating point constants)
+ * can produce multiple acceptable outputs.
+ */
+typedef struct demtest_mcase {
+	const char *dtmc_mangled;
+	const char **dtmc_demangled;
+} demtest_mcase_t;
+
+typedef struct demtest_mgroup {
+	sysdem_lang_t	dtmg_lang;
+	const char	*dtmg_name;
+	demtest_mcase_t	*dtmg_tests[];
+} demtest_mgroup_t;
+
+#define	TM(_m, ...) &(demtest_mcase_t){		\
+	.dtmc_mangled = _m,			\
+	.dtmc_demangled = (const char *[]){	\
+		__VA_ARGS__,			\
+		NULL				\
+	}					\
+}
+
+#define	MGROUP(_name, _lang, ...)		\
+	static demtest_mgroup_t _name = {	\
+		.dtmg_name = #_name,		\
+		.dtmg_lang = _lang,		\
+		.dtmg_tests = {			\
+			__VA_ARGS__,		\
+			NULL			\
+		}				\
+	};					\
+	DATA_SET(demangle_mtests, _name)
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif /* _DEMANGLE_TEST_H */
